%global fuse3ver 3.10.5

Name:    fuse3
Version: %{fuse3ver}
Release: 5
Summary: User space File System of fuse3
License: GPL+ and LGPLv2+
URL:     http://fuse.sf.net
Source0: https://github.com/libfuse/libfuse/releases/download/fuse-%{fuse3ver}/fuse-%{fuse3ver}.tar.xz
Source1: fuse.conf

Patch1:        0001-fix-chown-and-mknod-failed.patch
Patch2:        0002-revert-fuse_daemonize-chdir-to-even-if-not-run.patch
Patch3:        0003-Fix-fd-leak-with-clone_fd.patch

BuildRequires: libselinux-devel, pkgconfig, systemd-udev, meson, fdupes
BuildRequires: autoconf, automake, libtool, gettext-devel, ninja-build
Requires:      which, fuse-common
Recommends:    %{name}-help = %{version}-%{release}
Conflicts:     filesystem < 3
Provides:      %{name}-libs
Obsoletes:     %{name}-libs

%description
FUSE (Filesystem in Userspace) is an interface for userspace programs to export
a filesystem to the Linux kernel. The FUSE project consists of two components:
the fuse kernel module (maintained in the regular kernel repositories) and the
libfuse userspace library (maintained in this repository). libfuse provides the
reference implementation for communicating with the FUSE kernel module.

%package -n fuse-common
Version:    %{fuse3ver}
Summary:    Common files (fuse.conf) for File System in Userspace (FUSE) v2 and v3
License:    GPL+

%description -n fuse-common
Common files (fuse.conf) for File System in Userspace (FUSE) v2 and v3

%package -n fuse3-devel
Version:        %{fuse3ver}
Summary:        User space File System of fuse3 devel files
Obsoletes:      %{name}3-libs
Requires:       %{name}
License:        LGPLv2+
Conflicts:      filesystem < 3

%description -n fuse3-devel
This package contains all include files, libraries and configuration
files needed to develop programs that use the fuse3.

%package help
Summary: Including man files for fuse
Requires: man

%description    help
This contains man files for the using of fuse

%prep
%autosetup -n fuse-%{fuse3ver} -p1

%build
%meson
%meson_build

%install
export MESON_INSTALL_DESTDIR_PREFIX=%{buildroot}/usr
%meson_install

chmod 0755 %{buildroot}/%{_bindir}/fusermount3

rm -f %{buildroot}/%{_libdir}/*.a
rm -f %{buildroot}%{_sysconfdir}/init.d/fuse3
rm -f %{buildroot}/usr/lib/udev/rules.d/99-fuse3.rules
find %{buildroot} -type f -name "*.la" -delete -print

# Install config-file
install -p -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}


%post -n fuse3 -p /sbin/ldconfig
%postun -n fuse3 -p /sbin/ldconfig

%files

%files -n fuse3
%doc {AUTHORS,ChangeLog*,README*}
%license LICENSE *GPL2.txt
%{_sbindir}/mount.fuse3
%attr(4755,root,root) %{_bindir}/fusermount3
%{_libdir}/libfuse3.so.*

%files -n fuse-common
%config(noreplace) %{_sysconfdir}/fuse.conf

%files -n fuse3-devel
%{_includedir}/fuse3/
%{_libdir}/libfuse3.so
%{_libdir}/pkgconfig/fuse3.pc

%files help
%{_mandir}/man1/*
%{_mandir}/man8/*

%changelog
* Wed Dec 7 2022 Zhiqiang Liu <liuzhiqiang26@huawei.com> -3.10.5-5
- fix fd leak with clone_fd

* Fri Nov 4 2022 zhanchengbin <zhanchengbin1@huawei.com> -3.10.5-4
- Synchronize Version

* Sat Dec 25 2021 yanglongkang <yanglongkang@huawei.com> -3.10.5-3
- correcting Source0 error

* Tue Nov 30 2021 lixiaokeng <lixiaokeng@huawei.com> -3.10.5-2
- revert fuse_daemonize chdir to / even if not run background.

* Tue Nov 23 2021 lixiaokeng <lixiaokeng@huawei.com> -3.10.5-1
- upgrade to 3.10.5

* Mon Jul 26 2021 lixiaokeng <lixiaokeng@huawei.com> -3.9.2-6
- autosetup patch

* Tue Jun 15 2021 Wenlong Ding <wenlong.ding@turbolinux.com.cn> -3.9.2-5
- Add fuse3-devel install requires fuse3 package.

* Sat May 22 2021 yanglongkang <yanglongkang@huawei.com> -3.9.2-4
- fuse3 init

* Thu Dec 17 2020 yanglongkang <yanglongkang@huawei.com> -3.9.2-3
- set help package as install requires

* Mon Jul 13 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> -3.9.2-2
- backport upstream bugfix patches

* Mon Jul 06 2020 Youming Zhang <zhangyouming4@huawei.com> -3.9.2-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update fuse3 from 3.9.0 to 3.9.2

* Tue Jun 30 2020 Zhiqiang Liu <liuzhiqiang26@huawei.com> - 2.9.9-1
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:renumber patches

* Sat Jan 11 2020 openEuler Buildteam <buildteam@openeuler.org> - 2.9.9-0
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:update fuse2 from 2.9.7 to 2.9.9,
       update fuse3 from 3.2.3 to 3.9.0

* Sat Dec 28 2019 openEuler Buildteam <buildteam@openeuler.org> - 2.9.7-23
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:sync bugfix from community

* Wed Sep 4 2019 zoujing <zoujing13@huawei.com> - 2.9.7-22
- Type:enhancemnet
- ID:NA
- SUG:restart
- DESCi:openEuler Debranding

* Fri Aug 23 2019 zoujing <zoujing13@huawei.com> - 2.9.7-21
- Type:enhancement
- ID:NA
- SUG:restart
- DESC: remove sensitive information

* Thu Aug 22 2019 zoujing <zoujing13@huawei.com> - 2.9.7-20
- Type: enhancement
- ID:NA
- SUG:restart
- DESC:rename patch name

* Mon Aug 12 2019 huangzheng <huangzheng22@huawei.com> - 2.9.7-19
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:safety code review, delete sensitive information

* Tue Jul 23 2019 Shijie Luo <luoshijie1@huawei.com> - 2.9.7-18
- Type:bugfix
- ID:NA
- SUG:NA
- DESC:fix fuse crash problem when rm node

* Fri Apr 19 2019 wangchan <wangchan9@huawei.com> - 2.9.7-17
- Type:bugfix
- ID:NA
- SUG:NA
- DESC: bfuse-fix-fs-cleanup
        fuse_opt_parse(): fix memory leak
        fusermount: refuse unknown options
        fusermount: whitelist known-good filesystems for mountpoints
        fusermount: Fix memory leaks
        Fix invalid free of memory pointer in 'struct fuse_buf'
        Fix memory leak of FUSE modules

* Fri Mar 22 2019 yangjian<yangjian79@huawei.com> - 2.9.7-16
- Type:cves
- ID:CVE-2018-10906
- SUG:NA
- DESC:fix CVE-2018-10906

* Fri Jan 25 2019 liuqianya<liuqianya@huawei.com> - 2.9.7-15
- Type:bugfix
- ID:NA
- SUG:NA
  DESC:increase idle thread
       invalid free and core
       memory leak and wild ptr
       fuse exit when got EINVAL error

* Wed Jul 18 2018 openEuler Buildteam <buildteam@openeuler.org> - 2.9.7-14
- Package init

